#ifndef BARGRAF_H
#define BARGRAF_H

// Deklaracje

#define BAR_PB_MASK 	0x03
#define BAR_PC_MASK 	0x0F
#define BAR_PD_MASK 	0xE0
#define BAR_IN1_ON		PORTB |= _BV(1);
#define BAR_IN2_ON		PORTB |= _BV(0);
#define BAR_IN3_ON		PORTD |= _BV(7);
#define BAR_IN4_ON		PORTD |= _BV(6);
#define BAR_IN5_ON		PORTD |= _BV(5);
#define BAR_IN1_OFF		PORTB &= ~_BV(1);
#define BAR_IN2_OFF		PORTB &= ~_BV(0);
#define BAR_IN3_OFF		PORTD &= ~_BV(7);
#define BAR_IN4_OFF		PORTD &= ~_BV(6);
#define BAR_IN5_OFF		PORTD &= ~_BV(5);
#define BAR_OUT1_ON		PORTC |= _BV(0);
#define BAR_OUT2_ON		PORTC |= _BV(1);
#define BAR_OUT3_ON		PORTC |= _BV(2);
#define BAR_OUT4_ON		PORTC |= _BV(3);
#define BAR_OUT1_OFF	PORTC &= ~_BV(0);
#define BAR_OUT2_OFF	PORTC &= ~_BV(1);
#define BAR_OUT3_OFF	PORTC &= ~_BV(2);
#define BAR_OUT4_OFF	PORTC &= ~_BV(3);
#define BAR_WAIT		_delay_us(500);
#define BAR_RED			0
#define BAR_GRN			1
#define BAR_OFF			0
#define BAR_ON			1
#define BAR_BLINK		2

//Prototypy funkcji

void bargraf_init( void );
void bargraf_draw( void );
void bargraf_line( int kolor, int ile,int status );
void bargraf_clear( void );

#endif