#include <stdio.h>
#include <stdlib.h>

float ConvPos(float pos){
	float tmp;
	//5209.644531
	//52 09 64.4
	int d=pos/100;
	//float m=(int)pos-d*100;
	float m=pos-d*100.0;
	//float s=((int)(pos*1000.0)-d*100000-m*1000)/10.0;
	//printf("%d - %.4f\n",d,m);	

//	return d+(m*60.0+s)/3600.0;
	return d+m/60.0;

}

typedef struct{
	unsigned long int time;
	float posx;
	float posy;
}gps_data;

int main(int argc, char** argv){

	gps_data gpsdata;
	int eeprompos=0;
	int i;

	FILE* plik;
	FILE* zapis;

	if(argc>=2){plik=fopen(argv[1],"r");}
	else{plik=fopen("eeprom.hex","r");}

	if(argc>=3){zapis=fopen(argv[2],"w");}
	else{zapis=fopen("trasa.kml","w");}

	fputs("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n",zapis);
	fputs("<kml xmlns=\"http://www.opengis.net/kml/2.2\">\n",zapis);
	fputs("  <Document>\n",zapis);
	fputs("    <Style id=\"droga\">\n",zapis);
	fputs("      <LineStyle>\n",zapis);
	fputs("        <color>ff0000ff</color>\n",zapis);
	fputs("        <width>2</width>\n",zapis);
	fputs("      </LineStyle>\n",zapis);
	fputs("    </Style>\n",zapis);
	fputs("    <Folder>\n",zapis);
	fputs("      <Placemark>\n",zapis);
	fputs("        <name>Trasa GPS</name>\n",zapis);
	fputs("        <description>Opis wycieczki</description>\n",zapis);
	fputs("        <styleUrl>#droga</styleUrl>\n",zapis);
	fputs("        <MultiGeometry>\n",zapis);
	fputs("          <LineString>\n",zapis);
	fputs("            <tessellate>1</tessellate>\n",zapis);
	fputs("            <coordinates>\n",zapis);

	fread(&eeprompos,2,1,plik);
	printf("Ilosc pozycji: %d\n",eeprompos);

	for(i=0;i<eeprompos;i++){
		fread(&gpsdata.time,4,1,plik);
		if(gpsdata.time==-1)break;
		fread(&gpsdata.posx,4,1,plik);
		fread(&gpsdata.posy,4,1,plik);
		printf("POS %d\tT: %d X: %f Y: %f\n",i,gpsdata.time,gpsdata.posx,gpsdata.posy);	
		printf("POS %d\tT: %d X: %f Y: %f\n",i,gpsdata.time,ConvPos(gpsdata.posx),ConvPos(gpsdata.posy));	
		fprintf(zapis,"              %.5f,%.5f\n",ConvPos(gpsdata.posy),ConvPos(gpsdata.posx));
		//fprintf(zapis,"%.5f,%.5f\r\n",gpsdata.posx/100.0,gpsdata.posy/100.0);
	}

	fputs("            </coordinates>\n",zapis);
	fputs("          </LineString>\n",zapis);
	fputs("        </MultiGeometry>\n",zapis);
	fputs("      </Placemark>\n",zapis);
	fputs("    </Folder>\n",zapis);
	fputs("  </Document>\n",zapis);
	fputs("</kml>\n",zapis);
	fclose(plik);
	fclose(zapis);
}
